XIncludeFile "Include\ECluster_inc.pbi"

UseJPEGImageDecoder()

#Delay = 20

Structure WindowData
  Img.i
  Window.i
EndStructure

Global pwd$, MouseControl, Master, Host$, Slave, Window, Img, *WData.WindowData, Pos.Coord, rx.f, ry.f, lrx.f, lry.f, Para

; Mauspos ermitteln
Procedure GetMousePos(hWnd, *Pos.COORD)
  GetCursorPos_(Mouse.POINT)
  GetWindowRect_(hWnd, rect.RECT)
  *Pos\x = (mouse\x-rect\left)
  *Pos\y = (mouse\y-rect\top)
EndProcedure

; Zeigt den Desktop an
Procedure ShowDesktop(EMaster, Slave, Job, Event, *Mem, MemSize, *WData.WindowData)
  If Event = #Event_Job_Finished
    If *Mem And MemSize
      CatchImage(0, *Mem, MemSize, #PB_ImagePlugin_JPEG)
      ; Passt das Imaga an die Fenstergre an
      ResizeImage(0, WindowWidth(*WData\Window), WindowHeight(*WData\Window))
      ECluster_FreeMemory(*Mem)
      SetGadgetState(*WData\Img, ImageID(0))
      ; Warten und nchste Anfrage
      Delay(#Delay)
    EndIf
    ECluster_Master_DoJob(EMaster, "StreamDesktop", Slave, 0, @ShowDesktop(), *WData)
  ElseIf Event = #Event_Job_Denied
    MessageRequester("Verweigert", "Passwort falsch")
  EndIf
EndProcedure

Procedure Dummy(EMaster, Slave, Job, Event, *Mem, MemSize, UserData)
  
EndProcedure

; Initialisiert ECluster
If Not ECluster_Init("Include\ECluster.dll")
  MessageRequester("Fehler", "Konnte ECluster RPC - Bibliothek nicht initalisieren (Include\ECluster.dll)")
EndIf

; Startet den Master
Master = ECluster_Master_Init()

ECluster_Master_SetReceiveBlockSize(Master, 1024*1024)

Host$ = InputRequester("Host", "IP - Addresse oder Host des Slave eingeben", "localhost")

; Ld den Slave
Slave = ECluster_Master_AddSlave(Master, Host$, 4040)
If Not Slave
  MessageRequester("Fehler", "Konnte nicht zum Host verbinden")
  ECluster_Master_DeInit(Master)
  End
EndIf
; Mauskontrolle aktivieren
If MessageRequester("Mauskontrolle", "Maus des Remotepc kontrollieren?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
  MouseControl = #True
EndIf

pwd$ = InputRequester("Passwort", "Passwort eingeben: (fr den Test: geheim)", "")
Para = ECluster_Parameter_New()
ECluster_Parameter_AddString(Para, pwd$)
ECluster_Master_DoJob(Master, "CheckPWD", Slave, Para, @Dummy()) 



; ffnet ein Anzeigefenster
Window = OpenWindow(#PB_Any, 0, 0, 800, 600, "Desktop Stream Receiver (" + Host$ + ")", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_MaximizeGadget)
Img = ImageGadget(#PB_Any, 0, 0, 800, 600, 0)

; Startet die 1. Anrage
*WData = AllocateMemory(SizeOf(WindowData))
*WData\Window = Window
*WData\Img = Img
ECluster_Master_DoJob(Master, "StreamDesktop", Slave, 0, @ShowDesktop(), *WData)

Repeat
  Event = WaitWindowEvent(5)
  
  If MouseControl
    
    ; relative Mausposition in % ermitteln
    GetMousePos(WindowID(Window), @Pos)
    If Pos\x<0
      rx = 0
    ElseIf Pos\x>GadgetWidth(Img)
      rx = 100
    Else
      rx = Pos\x/GadgetWidth(Img)*100
    EndIf
    If Pos\y<0
      rxy = 0
    ElseIf Pos\y>GadgetHeight(Img)
      ry = 100
    Else
      ; Titelzeile bercksichtigen
      ry = (Pos\y-GetSystemMetrics_(#SM_CYCAPTION))/GadgetHeight(Img)*100
    EndIf
    
    ; nderung? Maus verschieben
    If (rx<>lrx) Or (ry<>lry)
      Para = ECluster_Parameter_New()
      ECluster_Parameter_AddLong(Para, rx)
      ECluster_Parameter_AddLong(Para, ry)
      ECluster_Master_DoJob(Master, "Control_SetMousePos", Slave, Para, @Dummy(), 0)
      lrx = rx
      lry = ry
    EndIf
    
    ; mausevents senden
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
          Case Img
            Select EventType()
              Case #PB_EventType_LeftDoubleClick
                ECluster_Master_DoJob(Master, "Control_Left_DoubleClick", Slave, 0, @Dummy(), 0)
              Case #PB_EventType_RightDoubleClick
                ECluster_Master_DoJob(Master, "Control_Right_DoubleClick", Slave, 0, @Dummy(), 0)
              Case #PB_EventType_LeftClick
                ECluster_Master_DoJob(Master, "Control_Left_Click", Slave, 0, @Dummy(), 0)
              Case #PB_EventType_RightClick
                ECluster_Master_DoJob(Master, "Control_Right_Click", Slave, 0, @Dummy(), 0)
            EndSelect
        EndSelect
    EndSelect
  EndIf
  
Until Event = #PB_Event_CloseWindow

; Beendet den Master
ECluster_Master_DeInit(Master)

; IDE Options = PureBasic 4.31 Beta 2 (Windows - x86)
; CursorPosition = 53
; FirstLine = 40
; Folding = -
; EnableThread
; EnableXP
; Executable = Master.exe
; DisableDebugger