XIncludeFile "Include\ECluster_inc.pbi"

EnableExplicit

UseJPEGImageEncoder()
Global Slave, Main

; Screenshot erstellen
Procedure MakeDesktopScreenshot()
  Protected Img, DeskDC, hDC
  
  Img = CreateImage(#PB_Any, GetSystemMetrics_(#SM_CXVIRTUALSCREEN), GetSystemMetrics_(#SM_CYVIRTUALSCREEN))
  hDC = StartDrawing(ImageOutput(Img))
    DeskDC = GetDC_(GetDesktopWindow_())
    BitBlt_(hDC, 0, 0, GetSystemMetrics_(#SM_CXVIRTUALSCREEN), GetSystemMetrics_(#SM_CYVIRTUALSCREEN), DeskDC, 0, 0, #SRCCOPY)
  StopDrawing()
  ReleaseDC_(GetDesktopWindow_(), DeskDC)
  ProcedureReturn Img
EndProcedure

Procedure SaveImageToMemory(Image, *MemSize, Format = #PB_ImagePlugin_JPEG, Compression = 9)
  Protected *Mem, MemSize, ImageDataPipe, PipeName$
  PipeName$ = "\\.\pipe\ImageDataPipe_" + Str(GetCurrentThreadId_()) ; <- Threadsicher
  MemSize = ImageDepth(Image)*ImageHeight(Image)*ImageWidth(Image)
  *Mem = AllocateMemory(MemSize)
  ImageDataPipe = CreateNamedPipe_(PipeName$, #PIPE_ACCESS_INBOUND | #FILE_FLAG_OVERLAPPED, #PIPE_TYPE_BYTE | #PIPE_READMODE_BYTE | #PIPE_NOWAIT, 1, MemSize, MemSize, #NMPWAIT_USE_DEFAULT_WAIT, #Null)
  SaveImage(Image, PipeName$, Format, Compression)
  ReadFile_(ImageDataPipe, *Mem, MemSize, *MemSize, #Null)
  CloseHandle_(ImageDataPipe)
  ProcedureReturn *Mem
EndProcedure

; Screenshot senden
Procedure ECluster_SendDesktop(hSlave, Master, JobNumber, Para)
  Protected Mutex, Img, *Mem, MemSize
  
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  If Not Mutex
    Mutex = CreateMutex()
    ECluster_Slave_SetMasterXtraData(hSlave, Master, Mutex)
  EndIf
  
  ; Screenshot speichern
  Img = MakeDesktopScreenshot()
  *Mem = SaveImageToMemory(Img, @MemSize)
  
  FreeImage(Img)
  
  ; Daten senden
  ProcedureReturn ECluster_Return_Memory(*Mem, MemSize)
EndProcedure

; Mauspos setzen
Procedure ECluster_SetMousePos(hSlave, Master, JobNumber, Para)
  Protected x.f, y.f, rx, ry, Mutex
  
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  If Not Mutex
    Mutex = CreateMutex()
    ECluster_Slave_SetMasterXtraData(hSlave, Master, Mutex)
  EndIf
  
  x = (ECluster_Parameter_GetLong(Para)/100)*GetSystemMetrics_(#SM_CXVIRTUALSCREEN)
  y = (ECluster_Parameter_GetLong(Para)/100)*GetSystemMetrics_(#SM_CYVIRTUALSCREEN)
  rx = Int(x)
  ry = Int(y)
  
  LockMutex(Mutex)
  
  SetCursorPos_(rx, ry)
  
  UnlockMutex(Mutex)
  
EndProcedure

Procedure ECluster_Left_Click(hSlave, Master, JobNumber, Para)
  Protected xy.point
  Protected Mutex
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  If Mutex
    
    LockMutex(Mutex)
    
    GetCursorPos_(xy.point)
    mouse_event_(#MOUSEEVENTF_LEFTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_LEFTUP, xy\x, xy\y, 0, 0)
    
    UnlockMutex(Mutex)
  EndIf
EndProcedure

Procedure ECluster_Left_DoubleClick(hSlave, Master, JobNumber, Para)
  Protected xy.point
  
  Protected Mutex
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  If Mutex
    
    LockMutex(Mutex)
    
    GetCursorPos_(xy.point)
    
    mouse_event_(#MOUSEEVENTF_LEFTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_LEFTUP, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_LEFTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_LEFTUP, xy\x, xy\y, 0, 0)
    
    UnlockMutex(Mutex)
    
  EndIf
EndProcedure

Procedure ECluster_Right_Click(hSlave, Master, JobNumber, Para)
  Protected xy.point
  
  Protected Mutex
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  If Mutex
    
    LockMutex(Mutex)
    
    GetCursorPos_(xy.point)
    mouse_event_(#MOUSEEVENTF_RIGHTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_RIGHTUP, xy\x, xy\y, 0, 0)
    
    UnlockMutex(Mutex)
  EndIf
EndProcedure

Procedure ECluster_Right_DoubleClick(hSlave, Master, JobNumber, Para)
  Protected xy.point
  
  Protected Mutex
  Mutex = ECluster_Slave_GetMasterXtraData(hSlave, Master)
  
  If Mutex
    
    LockMutex(Mutex)
    
    GetCursorPos_(xy.point)
    mouse_event_(#MOUSEEVENTF_RIGHTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_RIGHTUP, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_RIGHTDOWN, xy\x, xy\y, 0, 0)
    mouse_event_(#MOUSEEVENTF_RIGHTUP, xy\x, xy\y, 0, 0)
    
    UnlockMutex(Mutex)
    
  EndIf
  
EndProcedure

; PWD - vergleichen
Procedure CheckPWD(hSlave, Master, JobNumber, Para)
  Protected refpwd$ = "geheim"
  Protected pwd$ = ECluster_Parameter_GetString(Para)
  If refpwd$ = pwd$
    ECluster_Slave_SetMasterXtraData(hSlave, Master, #True)
    ProcedureReturn ECluster_Return_Long(#True)
  Else
    ECluster_Slave_SetMasterXtraData(hSlave, Master, #False)
    ProcedureReturn ECluster_Return_Long(#False)
  EndIf
EndProcedure

; Darf Master Jobs ausfhren?
Procedure Check(Slave, Master, Job$)
  If LCase(Job$)<>"checkpwd"
    ProcedureReturn ECluster_Slave_GetMasterXtraData(Slave, Master)
  EndIf
  ProcedureReturn #True
EndProcedure

; AccessChecker festlegen
Procedure Slave_EventCB(Slave, Master, Job$, EventType, UserData)
  If EventType = #Event_Master_Connect
    ECluster_Slave_SetMasterJobAccessCheck(Slave, Master, @Check())
  EndIf
EndProcedure

; Initialisiert ECluster
If Not ECluster_Init("Include\ECluster.dll")
  MessageRequester("Fehler", "Konnte ECluster RPC - Bibliothek nicht initalisieren (Include\ECluster.dll)")
  End
EndIf

; Initialisiert den Slave auf Port 4040 mit 32 Threads
Slave = ECluster_Slave_Init(4040, 32)
If Not Slave
  MessageRequester("Fehler", "Konnte Slave Service nicht starten")
  End
EndIf

ECluster_Slave_SetReceiveBlockSize(Slave, 1024*1024)

ECluster_Slave_SetCallback(Slave, @Slave_EventCB(), #Null)

; Services registrieren

; Passwortcheck
ECluster_Slave_AddJob(Slave, "CheckPWD", "Passwort checken", @CheckPWD())

; Desktop Streamer
ECluster_Slave_AddJob(Slave, "StreamDesktop", "Screenshot senden", @ECluster_SendDesktop())

; Maus Kontrolle
ECluster_Slave_AddJob(Slave, "Control_SetMousePos", "Mausposition stetzen (2 long Parameter xrel,yrel (0-100))", @ECluster_SetMousePos())

ECluster_Slave_AddJob(Slave, "Control_Left_Click", "Linker Mausklick", @ECluster_Left_Click())
ECluster_Slave_AddJob(Slave, "Control_Left_DoubleClick", "Linker Doppelklick", @ECluster_Left_DoubleClick())

ECluster_Slave_AddJob(Slave, "Control_Right_Click", "Rechter Mausklick", @ECluster_Right_Click())
ECluster_Slave_AddJob(Slave, "Control_Right_DoubleClick", "Rechter Doppelklick", @ECluster_Right_DoubleClick())

Main = OpenWindow(#PB_Any, 0, 0, 250, 0, "Desktop Streamer", #PB_Window_SystemMenu)

; Autokompression an
ECluster_Slave_SetCompressionOptions(Slave, 1024, 9)

Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow

; Deinitialisieren
ECluster_Slave_DeInit(Slave)

; IDE Options = PureBasic 4.31 Beta 2 (Windows - x86)
; CursorPosition = 154
; FirstLine = 145
; Folding = --
; EnableThread
; EnableXP
; Executable = Slave_SE.exe
; DisableDebugger